using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CoreAudioApi;

namespace CoreAudioSample
{
    public partial class Form1 : Form
    {
        private MMDevice device;

        public Form1()
        {
            InitializeComponent();
            MMDeviceEnumerator DevEnum = new MMDeviceEnumerator();
            device = DevEnum.GetDefaultAudioEndpoint(EDataFlow.eRender, ERole.eMultimedia);
            tbMaster.Value = (int)(device.AudioEndpointVolume.MasterVolumeLevelScalar * 100);
            device.AudioEndpointVolume.OnVolumeNotification += new AudioEndpointVolumeNotificationDelegate(AudioEndpointVolume_OnVolumeNotification);
            timer1.Enabled = true;
        }

        void AudioEndpointVolume_OnVolumeNotification(AudioVolumeNotificationData data)
        {
            if (this.InvokeRequired)
            {
                object[] Params = new object[1];
                Params[0] = data;
                this.Invoke(new AudioEndpointVolumeNotificationDelegate(AudioEndpointVolume_OnVolumeNotification), Params);
            }
            else
            {
                tbMaster.Value = (int)(data.MasterVolume * 100);
            }
        }

        private void tbMaster_Scroll(object sender, EventArgs e)
        {
            device.AudioEndpointVolume.MasterVolumeLevelScalar = ((float)tbMaster.Value / 100.0f);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            pkMaster.Value = (int)(device.AudioMeterInformation.MasterPeakValue * 100);
        }


        private void Form1_Load(object sender, EventArgs e)
        {
              string[] myPort; //  
              myPort = System.IO.Ports.SerialPort.GetPortNames(); //     
              comboBox1.Items.AddRange(myPort); //     (comboBox) 


        
        }
        private void button3_Click(object sender, EventArgs e)
        {

            if ((serialPort1.IsOpen == false) && (comboBox1.Text != ""))
            {
                serialPort1.BaudRate = 9600;
                serialPort1.PortName = comboBox1.Text.ToString();
                serialPort1.Open();
            }
          }

        private void comboBox1_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            serialPort1.PortName = comboBox1.Text.ToString();
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {

            string line = serialPort1.ReadLine();
            this.BeginInvoke(new LineReceivedEvent(LineReceived), line);
        }
        private delegate void LineReceivedEvent(string line);
        private void LineReceived(string line)
        
        {
            if ((line.ToString()) == "0")
            {
                try
                {
                    device.AudioEndpointVolume.MasterVolumeLevelScalar -= 0.05f;
                }
                catch
                {
                    device.AudioEndpointVolume.MasterVolumeLevelScalar = 0;
                }
            }
            if ((line.ToString()) == "1")
            {
                try
                {
                    device.AudioEndpointVolume.MasterVolumeLevelScalar += 0.05f;
                }
                catch { device.AudioEndpointVolume.MasterVolumeLevelScalar = 1; }
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (serialPort1.IsOpen == true)
                serialPort1.Close();
        }
    }
}